﻿using ProjectSellPC.Repos;
using Unity;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectSellPC.Forms.Receipt
{
    public partial class ChequeForm : Form
    {
        private readonly IUnityContainer _container;
        private readonly IChequeRepository _ChequeRepository;

        public ChequeForm(IUnityContainer unityContainer, IChequeRepository ChequeRepository)
        {
            InitializeComponent();

            _container = unityContainer ?? throw new ArgumentNullException(nameof(unityContainer));
            _ChequeRepository = ChequeRepository ?? throw new ArgumentNullException(nameof(ChequeRepository));
        }

        private void ChequeForm_Load(object sender, EventArgs e)
        {
            try
            {
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при загрузке", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void LoadList() => ChequesDataGridView.DataSource = _ChequeRepository.ReadAll();

        private void addButton_Click(object sender, EventArgs e)
        {
            try
            {
                _container.Resolve<ChequeSettingsForm>().ShowDialog();
                LoadList();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при добавлении", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}
