﻿using ProjectSellPC.Entites;
using ProjectSellPC.Repos;
using ProjectSellPC.Entites.Enums;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
namespace ProjectSellPC.Forms.Receipt
{
    public partial class ChequeSettingsForm : Form
    {
        private readonly IChequeRepository _ChequeRepository;
        private readonly IProductRepository _productRepository;
        private readonly IClientRepository _customerRepository;

        public ChequeSettingsForm(IChequeRepository ChequeRepository, IProductRepository productRepository, IClientRepository customerRepository)
        {
            InitializeComponent();

            _ChequeRepository = ChequeRepository ?? throw new ArgumentNullException(nameof(ChequeRepository));
            _productRepository = productRepository ?? throw new ArgumentNullException(nameof(productRepository));
            _customerRepository = customerRepository ?? throw new ArgumentNullException(nameof(customerRepository));


            ProductColoumn.DataSource = _productRepository.ReadAll().ToList();
            ProductColoumn.DisplayMember = "Name";
            ProductColoumn.ValueMember = "Id";

            customerComboBox.DataSource = _customerRepository.ReadAll().ToList();
            customerComboBox.DisplayMember = "Name";
            customerComboBox.ValueMember = "Id";
        }

        public void ChequeSettingsForm_Load(object sender, EventArgs e)
        {

        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            try
            {
                if (productsDataGridView.RowCount < 1 || customerComboBox.SelectedItem == null)
                {
                    throw new Exception("Необходимо выбрать товар и клиента");
                }

                var products = CreateListProducts();
                var customer = (Client)customerComboBox.SelectedItem;

                var cheque = Cheque.CreateEntity(0, products, customer, DateTime.Now);
                _ChequeRepository.Create(cheque);

                Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при создании чека", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private List<ProductInCheque> CreateListProducts()
        {
            var list = new List<ProductInCheque>();
            foreach (DataGridViewRow row in productsDataGridView.Rows)
            {
                if (row.Cells["ProductColoumn"].Value == null || row.Cells["ProductCount"].Value == null)
                {
                    continue;
                }

                list.Add(ProductInCheque.CreateElement(Convert.ToInt32(row.Cells["ProductColoumn"].Value), Convert.ToInt32(row.Cells["ProductCount"].Value)));
            }

            return list;
        }
    }
}

