﻿using ProjectSellPC.DocBuilder;
using ProjectSellPC.DocumentsBuilder;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Unity;

namespace ProjectSellPC.Forms.DocReports
{
    public partial class DocReportForm : Form
    {
        private readonly IUnityContainer _container;

        public DocReportForm(IUnityContainer container)
        {
            InitializeComponent();

            _container = container ?? throw new ArgumentNullException(nameof(container));
        }

        private void DocReportForm_Load(object sender, EventArgs e)
        {

        }

        private void buildReportButton_Click(object sender, EventArgs e)
        {
            try
            {
                if (!entitiesCheckedListBox.GetItemChecked(0) && !entitiesCheckedListBox.GetItemChecked(1) && !entitiesCheckedListBox.GetItemChecked(2))
                {
                    throw new Exception("Не выбран ни один справочник для выгрузки");
                }

                var sfd = new SaveFileDialog()
                {
                    Filter = "Docx Files | *.docx"
                };

                if (sfd.ShowDialog() != DialogResult.OK)
                {
                    throw new Exception("Не выбран файла для отчета");
                }

                if (_container.Resolve<DocReport>().CreateDoc(sfd.FileName, entitiesCheckedListBox.GetItemChecked(0),
                 entitiesCheckedListBox.GetItemChecked(1),
                 entitiesCheckedListBox.GetItemChecked(2)))
                {
                    MessageBox.Show("Документ сформирован",
               "Формирование документа",
                     MessageBoxButtons.OK,
               MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Возникли ошибки при документа.Подробности в логах",
                     "Формирование документа", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Ошибка при создании отчета", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
    }
}